import { fabric } from "fabric";
import { useCallback } from "react";

export const useEditor = () => {
    const init = useCallback(({
        initialCanvas,
        initialContainer, //이부분 개빡치네 왜 안되는거야
    }: {
        initialCanvas: fabric.Canvas;
        initialContainer: HTMLDivElement,
    }) => {
        fabric.Object.prototype.set({
            cornerColor: "#FFF",
            cornerStyle: "circle",
            borderColor: "#3b82f6",
            borderScaleFactor: 1.5,
            transparentCorners: false,
            borderOpacityWhenMoving: 1,
            cornerStrokeColor: "#3b82f6",
        })

        const initialWorkspace = new fabric.Rect({
            width: 900,
            height: 1200,
            name: "clip",
            fill: "white",
            selectable: false,
            hasControls: false,
            shadow: new fabric.Shadow({
                color: "rgba(0,0,0,0.8)",
                blur: 5,
            })
        })

        initialCanvas.setWidth(900); //시부레 initialContainer.offsetWidth로 하면 왜 안되는거야
        initialCanvas.setHeight(1200);

        initialCanvas.add(initialWorkspace);
        initialCanvas.centerObject(initialWorkspace);
        initialCanvas.clipPath = initialWorkspace; // clip the canvas to the workspace

        const test = new fabric.Rect({
            height: 100,
            width: 100,
            fill: "black",
        });
        
        initialCanvas.add(test);
        initialCanvas.centerObject(test);
    },
    []
);

    return { init };
};